diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/emlsr-manager.h ns-3.39/src/wifi/model/eht/emlsr-manager.h
--- ns-3.38/src/wifi/model/eht/emlsr-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/wifi/model/eht/emlsr-manager.h	2023-07-05 14:23:48.109428400 -0700
@@ -0,0 +1,181 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef EMLSR_MANAGER_H
+#define EMLSR_MANAGER_H
+
+#include "ns3/mac48-address.h"
+#include "ns3/mgt-headers.h"
+#include "ns3/object.h"
+#include "ns3/sta-wifi-mac.h"
+
+#include <optional>
+#include <set>
+
+namespace ns3
+{
+
+class EhtFrameExchangeManager;
+class WifiMpdu;
+
+/**
+ * \ingroup wifi
+ *
+ * EmlsrManager is an abstract base class defining the API that EHT non-AP MLDs
+ * with EMLSR activated can use to handle the operations on the EMLSR links
+ */
+class EmlsrManager : public Object
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+    EmlsrManager();
+    ~EmlsrManager() override;
+
+    /**
+     * Set the wifi MAC. Note that it must be the MAC of an EHT non-AP MLD.
+     *
+     * \param mac the wifi MAC
+     */
+    void SetWifiMac(Ptr<StaWifiMac> mac);
+
+    /**
+     * Set the Transition Timeout advertised by the associated AP with EMLSR activated.
+     *
+     * \param timeout the advertised Transition Timeout
+     */
+    void SetTransitionTimeout(Time timeout);
+
+    /**
+     * \return the Transition Timeout, if advertised by the associated AP
+     */
+    std::optional<Time> GetTransitionTimeout() const;
+
+    /**
+     * Take actions to enable EMLSR mode on the given set of links, if non-empty, or
+     * disable EMLSR mode, otherwise.
+     *
+     * \param linkIds the IDs of the links on which EMLSR mode should be enabled
+     *                (empty to disable EMLSR mode)
+     */
+    void SetEmlsrLinks(const std::set<uint8_t>& linkIds);
+
+    /**
+     * \return the set of links on which EMLSR mode is enabled
+     */
+    const std::set<uint8_t>& GetEmlsrLinks() const;
+
+    /**
+     * Notify the reception of a management frame addressed to us.
+     *
+     * \param mpdu the received MPDU
+     * \param linkId the ID of the link over which the MPDU was received
+     */
+    void NotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
+
+  protected:
+    void DoDispose() override;
+
+    /**
+     * \return the MAC of the non-AP MLD managed by this EMLSR Manager.
+     */
+    Ptr<StaWifiMac> GetStaMac() const;
+
+    /**
+     * \param linkId the ID of the given link
+     * \return the EHT FrameExchangeManager attached to the non-AP STA operating on the given link
+     */
+    Ptr<EhtFrameExchangeManager> GetEhtFem(uint8_t linkId) const;
+
+    /**
+     * \return the ID of the link on which the EML Operating Mode Notification frame has to be sent
+     */
+    virtual uint8_t GetLinkToSendEmlNotification() = 0;
+
+    /**
+     * A previous EML Operating Mode Notification frame was dropped. Ask the subclass whether
+     * the frame needs to be re-sent on the given link (if any).
+     *
+     * \param mpdu the dropped MPDU that includes the EML Operating Mode Notification frame
+     * \return the ID of the link over which to re-send the frame, if needed
+     */
+    virtual std::optional<uint8_t> ResendNotification(Ptr<const WifiMpdu> mpdu) = 0;
+
+    Time m_emlsrPaddingDelay;    //!< EMLSR Padding delay
+    Time m_emlsrTransitionDelay; //!< EMLSR Transition delay
+
+  private:
+    /**
+     * Send an EML Operating Mode Notification frame.
+     */
+    void SendEmlOperatingModeNotification();
+
+    /**
+     * Notify the subclass of the reception of a management frame addressed to us.
+     *
+     * \param mpdu the received MPDU
+     * \param linkId the ID of the link over which the MPDU was received
+     */
+    virtual void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) = 0;
+
+    /**
+     * Notify the acknowledgment of the given MPDU.
+     *
+     * \param mpdu the acknowledged MPDU
+     */
+    void TxOk(Ptr<const WifiMpdu> mpdu);
+
+    /**
+     * Notify that the given MPDU has been discarded for the given reason.
+     *
+     * \param reason the reason why the MPDU was dropped
+     * \param mpdu the dropped MPDU
+     */
+    void TxDropped(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu);
+
+    /**
+     * This method is called to make an EMLSR mode change effective after the transition
+     * delay has elapsed or a notification response has been received from the AP.
+     */
+    void ChangeEmlsrMode();
+
+    /**
+     * Notify subclass that EMLSR mode changed.
+     */
+    virtual void NotifyEmlsrModeChanged() = 0;
+
+    Ptr<StaWifiMac> m_staMac;                     //!< the MAC of the managed non-AP MLD
+    std::optional<Time> m_emlsrTransitionTimeout; /**< Transition timeout advertised by APs with
+                                                       EMLSR activated */
+    std::set<uint8_t> m_emlsrLinks; //!< ID of the EMLSR links (empty if EMLSR mode is disabled)
+    std::optional<std::set<uint8_t>> m_nextEmlsrLinks; /**< ID of the links that will become the
+                                                            EMLSR links when the pending
+                                                            notification frame is acknowledged */
+    Time m_lastAdvPaddingDelay;                        //!< last advertised padding delay
+    Time m_lastAdvTransitionDelay;                     //!< last advertised transition delay
+    EventId m_transitionTimeoutEvent; /**< Timer started after the successful transmission of an
+                                           EML Operating Mode Notification frame */
+};
+
+} // namespace ns3
+
+#endif /* EMLSR_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/multi-link-element.cc ns-3.39/src/wifi/model/eht/multi-link-element.cc
--- ns-3.38/src/wifi/model/eht/multi-link-element.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/multi-link-element.cc	2023-07-05 14:23:48.109428400 -0700
@@ -49,8 +49,6 @@
     ret += (m_linkIdInfo.has_value() ? 1 : 0);
     ret += (m_bssParamsChangeCount.has_value() ? 1 : 0);
     ret += (m_mediumSyncDelayInfo.has_value() ? 2 : 0);
-    // NOTE Fig. 9-1002h of 802.11be D1.5 reports that the size of the EML Capabilities
-    // subfield is 3 octets, but this is likely a typo (the correct size is 2 octets)
     ret += (m_emlCapabilities.has_value() ? 2 : 0);
     ret += (m_mldCapabilities.has_value() ? 2 : 0);
     return ret;
@@ -155,17 +153,83 @@
     return count;
 }
 
+uint8_t
+CommonInfoBasicMle::EncodeEmlsrPaddingDelay(Time delay)
+{
+    auto delayUs = delay.GetMicroSeconds();
+
+    if (delayUs == 0)
+    {
+        return 0;
+    }
+
+    for (uint8_t i = 1; i <= 4; i++)
+    {
+        if (1 << (i + 4) == delayUs)
+        {
+            return i;
+        }
+    }
+
+    NS_ABORT_MSG("Value not allowed (" << delay.As(Time::US) << ")");
+    return 0;
+}
+
+Time
+CommonInfoBasicMle::DecodeEmlsrPaddingDelay(uint8_t value)
+{
+    NS_ABORT_MSG_IF(value > 4, "Value not allowed (" << +value << ")");
+    if (value == 0)
+    {
+        return MicroSeconds(0);
+    }
+    return MicroSeconds(1 << (4 + value));
+}
+
+uint8_t
+CommonInfoBasicMle::EncodeEmlsrTransitionDelay(Time delay)
+{
+    auto delayUs = delay.GetMicroSeconds();
+
+    if (delayUs == 0)
+    {
+        return 0;
+    }
+
+    for (uint8_t i = 1; i <= 5; i++)
+    {
+        if (1 << (i + 3) == delayUs)
+        {
+            return i;
+        }
+    }
+
+    NS_ABORT_MSG("Value not allowed (" << delay.As(Time::US) << ")");
+    return 0;
+}
+
+Time
+CommonInfoBasicMle::DecodeEmlsrTransitionDelay(uint8_t value)
+{
+    NS_ABORT_MSG_IF(value > 5, "Value not allowed (" << +value << ")");
+    if (value == 0)
+    {
+        return MicroSeconds(0);
+    }
+    return MicroSeconds(1 << (3 + value));
+}
+
 /**
  * MultiLinkElement
  */
-MultiLinkElement::MultiLinkElement(WifiMacType frameType)
-    : m_frameType(frameType),
+MultiLinkElement::MultiLinkElement(ContainingFrame frame)
+    : m_containingFrame(frame),
       m_commonInfo(std::in_place_type<std::monostate>) // initialize as UNSET
 {
 }
 
-MultiLinkElement::MultiLinkElement(Variant variant, WifiMacType frameType)
-    : MultiLinkElement(frameType)
+MultiLinkElement::MultiLinkElement(Variant variant, ContainingFrame frame)
+    : MultiLinkElement(frame)
 {
     NS_ASSERT(variant != UNSET);
     SetVariant(variant);
@@ -328,10 +392,110 @@
     return std::get<BASIC_VARIANT>(m_commonInfo).m_mediumSyncDelayInfo.has_value();
 }
 
-MultiLinkElement::PerStaProfileSubelement::PerStaProfileSubelement(Variant variant,
-                                                                   WifiMacType frameType)
+void
+MultiLinkElement::SetEmlsrSupported(bool supported)
+{
+    auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
+    if (!emlCapabilities.has_value())
+    {
+        emlCapabilities = CommonInfoBasicMle::EmlCapabilities{};
+    }
+    emlCapabilities->emlsrSupport = supported ? 1 : 0;
+}
+
+void
+MultiLinkElement::SetEmlsrPaddingDelay(Time delay)
+{
+    auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
+    if (!emlCapabilities.has_value())
+    {
+        emlCapabilities = CommonInfoBasicMle::EmlCapabilities{};
+    }
+    emlCapabilities->emlsrPaddingDelay = CommonInfoBasicMle::EncodeEmlsrPaddingDelay(delay);
+}
+
+void
+MultiLinkElement::SetEmlsrTransitionDelay(Time delay)
+{
+    auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
+    if (!emlCapabilities.has_value())
+    {
+        emlCapabilities = CommonInfoBasicMle::EmlCapabilities{};
+    }
+    emlCapabilities->emlsrTransitionDelay = CommonInfoBasicMle::EncodeEmlsrTransitionDelay(delay);
+}
+
+void
+MultiLinkElement::SetTransitionTimeout(Time timeout)
+{
+    auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
+    if (!emlCapabilities.has_value())
+    {
+        emlCapabilities = CommonInfoBasicMle::EmlCapabilities{};
+    }
+    auto timeoutUs = timeout.GetMicroSeconds();
+
+    if (timeoutUs == 0)
+    {
+        emlCapabilities->transitionTimeout = 0;
+    }
+    else
+    {
+        uint8_t i;
+        for (i = 1; i <= 10; i++)
+        {
+            if (1 << (i + 6) == timeoutUs)
+            {
+                emlCapabilities->transitionTimeout = i;
+                break;
+            }
+        }
+        NS_ABORT_MSG_IF(i > 10, "Value not allowed (" << timeout.As(Time::US) << ")");
+    }
+}
+
+bool
+MultiLinkElement::HasEmlCapabilities() const
+{
+    return std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities.has_value();
+}
+
+bool
+MultiLinkElement::IsEmlsrSupported() const
+{
+    return std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities->emlsrSupport;
+}
+
+Time
+MultiLinkElement::GetEmlsrPaddingDelay() const
+{
+    auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
+    NS_ASSERT(emlCapabilities);
+    return CommonInfoBasicMle::DecodeEmlsrPaddingDelay(emlCapabilities->emlsrPaddingDelay);
+}
+
+Time
+MultiLinkElement::GetEmlsrTransitionDelay() const
+{
+    auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
+    NS_ASSERT(emlCapabilities);
+    return CommonInfoBasicMle::DecodeEmlsrTransitionDelay(emlCapabilities->emlsrTransitionDelay);
+}
+
+Time
+MultiLinkElement::GetTransitionTimeout() const
+{
+    auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
+    NS_ASSERT(emlCapabilities);
+    if (emlCapabilities->transitionTimeout == 0)
+    {
+        return MicroSeconds(0);
+    }
+    return MicroSeconds(1 << (6 + emlCapabilities->transitionTimeout));
+}
+
+MultiLinkElement::PerStaProfileSubelement::PerStaProfileSubelement(Variant variant)
     : m_variant(variant),
-      m_frameType(frameType),
       m_staControl(0)
 {
 }
@@ -339,26 +503,23 @@
 MultiLinkElement::PerStaProfileSubelement::PerStaProfileSubelement(
     const PerStaProfileSubelement& perStaProfile)
     : m_variant(perStaProfile.m_variant),
-      m_frameType(perStaProfile.m_frameType),
       m_staControl(perStaProfile.m_staControl),
       m_staMacAddress(perStaProfile.m_staMacAddress)
 {
     // deep copy of the STA Profile field
-    if (perStaProfile.HasAssocRequest())
-    {
-        m_staProfile = std::make_unique<MgtAssocRequestHeader>(
-            *static_cast<MgtAssocRequestHeader*>(perStaProfile.m_staProfile.get()));
-    }
-    else if (perStaProfile.HasReassocRequest())
-    {
-        m_staProfile = std::make_unique<MgtReassocRequestHeader>(
-            *static_cast<MgtReassocRequestHeader*>(perStaProfile.m_staProfile.get()));
-    }
-    else if (perStaProfile.HasAssocResponse())
-    {
-        m_staProfile = std::make_unique<MgtAssocResponseHeader>(
-            *static_cast<MgtAssocResponseHeader*>(perStaProfile.m_staProfile.get()));
-    }
+    auto staProfileCopy = [&](auto&& frame) {
+        using Ptr = std::decay_t<decltype(frame)>;
+        if constexpr (std::is_same_v<Ptr, std::monostate>)
+        {
+            return;
+        }
+        else
+        {
+            using T = std::decay_t<decltype(*frame.get())>;
+            m_staProfile = std::make_unique<T>(*frame.get());
+        }
+    };
+    std::visit(staProfileCopy, perStaProfile.m_staProfile);
 }
 
 MultiLinkElement::PerStaProfileSubelement&
@@ -371,26 +532,23 @@
     }
 
     m_variant = perStaProfile.m_variant;
-    m_frameType = perStaProfile.m_frameType;
     m_staControl = perStaProfile.m_staControl;
     m_staMacAddress = perStaProfile.m_staMacAddress;
 
     // deep copy of the STA Profile field
-    if (perStaProfile.HasAssocRequest())
-    {
-        m_staProfile = std::make_unique<MgtAssocRequestHeader>(
-            *static_cast<MgtAssocRequestHeader*>(perStaProfile.m_staProfile.get()));
-    }
-    else if (perStaProfile.HasReassocRequest())
-    {
-        m_staProfile = std::make_unique<MgtReassocRequestHeader>(
-            *static_cast<MgtReassocRequestHeader*>(perStaProfile.m_staProfile.get()));
-    }
-    else if (perStaProfile.HasAssocResponse())
-    {
-        m_staProfile = std::make_unique<MgtAssocResponseHeader>(
-            *static_cast<MgtAssocResponseHeader*>(perStaProfile.m_staProfile.get()));
-    }
+    auto staProfileCopy = [&](auto&& frame) {
+        using Ptr = std::decay_t<decltype(frame)>;
+        if constexpr (std::is_same_v<Ptr, std::monostate>)
+        {
+            return;
+        }
+        else
+        {
+            using T = std::decay_t<decltype(*frame.get())>;
+            m_staProfile = std::make_unique<T>(*frame.get());
+        }
+    };
+    std::visit(staProfileCopy, perStaProfile.m_staProfile);
 
     return *this;
 }
@@ -445,50 +603,35 @@
 MultiLinkElement::PerStaProfileSubelement::SetAssocRequest(
     const std::variant<MgtAssocRequestHeader, MgtReassocRequestHeader>& assoc)
 {
-    switch (m_frameType)
-    {
-    case WIFI_MAC_MGT_ASSOCIATION_REQUEST:
-        m_staProfile =
-            std::make_unique<MgtAssocRequestHeader>(std::get<MgtAssocRequestHeader>(assoc));
-        break;
-    case WIFI_MAC_MGT_REASSOCIATION_REQUEST:
-        m_staProfile =
-            std::make_unique<MgtReassocRequestHeader>(std::get<MgtReassocRequestHeader>(assoc));
-        break;
-    default:
-        NS_ABORT_MSG("Invalid frame type: " << m_frameType);
-    }
+    std::visit(
+        [&](auto&& frame) {
+            m_staProfile = std::make_unique<std::decay_t<decltype(frame)>>(frame);
+        },
+        assoc);
 }
 
 void
 MultiLinkElement::PerStaProfileSubelement::SetAssocRequest(
     std::variant<MgtAssocRequestHeader, MgtReassocRequestHeader>&& assoc)
 {
-    switch (m_frameType)
-    {
-    case WIFI_MAC_MGT_ASSOCIATION_REQUEST:
-        m_staProfile = std::make_unique<MgtAssocRequestHeader>(
-            std::move(std::get<MgtAssocRequestHeader>(assoc)));
-        break;
-    case WIFI_MAC_MGT_REASSOCIATION_REQUEST:
-        m_staProfile = std::make_unique<MgtReassocRequestHeader>(
-            std::move(std::get<MgtReassocRequestHeader>(assoc)));
-        break;
-    default:
-        NS_ABORT_MSG("Invalid frame type: " << m_frameType);
-    }
+    std::visit(
+        [&](auto&& frame) {
+            using T = std::decay_t<decltype(frame)>;
+            m_staProfile = std::make_unique<T>(std::forward<T>(frame));
+        },
+        assoc);
 }
 
 bool
 MultiLinkElement::PerStaProfileSubelement::HasAssocRequest() const
 {
-    return m_staProfile && m_frameType == WIFI_MAC_MGT_ASSOCIATION_REQUEST;
+    return std::holds_alternative<std::unique_ptr<MgtAssocRequestHeader>>(m_staProfile);
 }
 
 bool
 MultiLinkElement::PerStaProfileSubelement::HasReassocRequest() const
 {
-    return m_staProfile && m_frameType == WIFI_MAC_MGT_REASSOCIATION_REQUEST;
+    return std::holds_alternative<std::unique_ptr<MgtReassocRequestHeader>>(m_staProfile);
 }
 
 AssocReqRefVariant
@@ -496,40 +639,35 @@
 {
     if (HasAssocRequest())
     {
-        return *static_cast<MgtAssocRequestHeader*>(m_staProfile.get());
+        return *std::get<std::unique_ptr<MgtAssocRequestHeader>>(m_staProfile);
     }
     NS_ABORT_UNLESS(HasReassocRequest());
-    return *static_cast<MgtReassocRequestHeader*>(m_staProfile.get());
+    return *std::get<std::unique_ptr<MgtReassocRequestHeader>>(m_staProfile);
 }
 
 void
 MultiLinkElement::PerStaProfileSubelement::SetAssocResponse(const MgtAssocResponseHeader& assoc)
 {
-    NS_ABORT_IF(m_frameType != WIFI_MAC_MGT_ASSOCIATION_RESPONSE &&
-                m_frameType != WIFI_MAC_MGT_REASSOCIATION_RESPONSE);
     m_staProfile = std::make_unique<MgtAssocResponseHeader>(assoc);
 }
 
 void
 MultiLinkElement::PerStaProfileSubelement::SetAssocResponse(MgtAssocResponseHeader&& assoc)
 {
-    NS_ABORT_IF(m_frameType != WIFI_MAC_MGT_ASSOCIATION_RESPONSE &&
-                m_frameType != WIFI_MAC_MGT_REASSOCIATION_RESPONSE);
     m_staProfile = std::make_unique<MgtAssocResponseHeader>(std::move(assoc));
 }
 
 bool
 MultiLinkElement::PerStaProfileSubelement::HasAssocResponse() const
 {
-    return m_staProfile && (m_frameType == WIFI_MAC_MGT_ASSOCIATION_RESPONSE ||
-                            m_frameType == WIFI_MAC_MGT_REASSOCIATION_RESPONSE);
+    return std::holds_alternative<std::unique_ptr<MgtAssocResponseHeader>>(m_staProfile);
 }
 
 MgtAssocResponseHeader&
 MultiLinkElement::PerStaProfileSubelement::GetAssocResponse() const
 {
     NS_ABORT_IF(!HasAssocResponse());
-    return *static_cast<MgtAssocResponseHeader*>(m_staProfile.get());
+    return *std::get<std::unique_ptr<MgtAssocResponseHeader>>(m_staProfile);
 }
 
 uint8_t
@@ -558,10 +696,25 @@
 
     ret += GetStaInfoLength();
 
-    if (HasAssocRequest() || HasReassocRequest() || HasAssocResponse())
-    {
-        ret += m_staProfile->GetSerializedSize();
-    }
+    auto staProfileSize = [&](auto&& frame) {
+        using T = std::decay_t<decltype(frame)>;
+        if constexpr (std::is_same_v<T, std::monostate>)
+        {
+            NS_ASSERT_MSG(std::holds_alternative<std::monostate>(m_containingFrame),
+                          "Missing management frame for Per-STA Profile subelement");
+            return static_cast<uint32_t>(0);
+        }
+        else
+        {
+            using U = std::decay_t<decltype(*frame)>;
+            NS_ASSERT_MSG(
+                std::holds_alternative<std::reference_wrapper<const U>>(m_containingFrame),
+                "Containing frame type and frame type in Per-STA Profile do not match");
+            const auto& containing = std::get<std::reference_wrapper<const U>>(m_containingFrame);
+            return frame->GetSerializedSizeInPerStaProfile(containing);
+        }
+    };
+    ret += std::visit(staProfileSize, m_staProfile);
 
     return ret;
 }
@@ -577,10 +730,25 @@
         WriteTo(start, m_staMacAddress);
     }
     // TODO add other subfields of the STA Info field
-    if (HasAssocRequest() || HasReassocRequest() || HasAssocResponse())
-    {
-        m_staProfile->Serialize(start);
-    }
+    auto staProfileSerialize = [&](auto&& frame) {
+        using T = std::decay_t<decltype(frame)>;
+        if constexpr (std::is_same_v<T, std::monostate>)
+        {
+            NS_ASSERT_MSG(std::holds_alternative<std::monostate>(m_containingFrame),
+                          "Missing management frame for Per-STA Profile subelement");
+            return;
+        }
+        else
+        {
+            using U = std::decay_t<decltype(*frame)>;
+            NS_ASSERT_MSG(
+                std::holds_alternative<std::reference_wrapper<const U>>(m_containingFrame),
+                "Containing frame type and frame type in Per-STA Profile do not match");
+            const auto& containing = std::get<std::reference_wrapper<const U>>(m_containingFrame);
+            frame->SerializeInPerStaProfile(start, containing);
+        }
+    };
+    std::visit(staProfileSerialize, m_staProfile);
 }
 
 uint16_t
@@ -588,46 +756,37 @@
                                                                        uint16_t length)
 {
     Buffer::Iterator i = start;
-    uint16_t count = 0;
 
     m_staControl = i.ReadLsbtohU16();
-    count += 2;
-
     i.ReadU8(); // STA Info Length
-    count++;
 
     if (HasStaMacAddress())
     {
         ReadFrom(i, m_staMacAddress);
-        count += 6;
     }
 
     // TODO add other subfields of the STA Info field
+    uint16_t count = i.GetDistanceFrom(start);
 
-    if (count >= length)
+    NS_ASSERT_MSG(count <= length,
+                  "Bytes read (" << count << ") exceed expected number (" << length << ")");
+
+    if (count == length)
     {
         return count;
     }
 
-    if (m_frameType == WIFI_MAC_MGT_ASSOCIATION_REQUEST)
-    {
-        MgtAssocRequestHeader assoc;
-        count += assoc.Deserialize(i);
-        SetAssocRequest(std::move(assoc));
-    }
-    else if (m_frameType == WIFI_MAC_MGT_REASSOCIATION_REQUEST)
-    {
-        MgtReassocRequestHeader reassoc;
-        count += reassoc.Deserialize(i);
-        SetAssocRequest(std::move(reassoc));
-    }
-    else if (m_frameType == WIFI_MAC_MGT_ASSOCIATION_RESPONSE ||
-             m_frameType == WIFI_MAC_MGT_REASSOCIATION_RESPONSE)
-    {
-        MgtAssocResponseHeader assoc;
-        count += assoc.Deserialize(i);
-        SetAssocResponse(assoc);
-    }
+    auto staProfileDeserialize = [&](auto&& frame) {
+        using T = std::decay_t<decltype(frame)>;
+        if constexpr (!std::is_same_v<T, std::monostate>)
+        {
+            using U = std::decay_t<decltype(frame.get())>;
+            U assoc;
+            count += assoc.DeserializeFromPerStaProfile(i, length - count, frame.get());
+            m_staProfile = std::make_unique<U>(std::move(assoc));
+        }
+    };
+    std::visit(staProfileDeserialize, m_containingFrame);
 
     return count;
 }
@@ -637,8 +796,7 @@
 {
     auto variant = GetVariant();
     NS_ABORT_IF(variant == UNSET);
-    NS_ABORT_IF(m_frameType == WIFI_MAC_DATA);
-    m_perStaProfileSubelements.emplace_back(variant, m_frameType);
+    m_perStaProfileSubelements.emplace_back(variant);
 }
 
 std::size_t
@@ -682,6 +840,7 @@
 
     for (const auto& subelement : m_perStaProfileSubelements)
     {
+        subelement.m_containingFrame = m_containingFrame;
         ret += subelement.GetSerializedSize();
     }
 
@@ -748,11 +907,14 @@
     {
         switch (static_cast<SubElementId>(i.PeekU8()))
         {
-        case PER_STA_PROFILE_SUBELEMENT_ID:
+        case PER_STA_PROFILE_SUBELEMENT_ID: {
             AddPerStaProfileSubelement();
-            i = GetPerStaProfile(GetNPerStaProfileSubelements() - 1).Deserialize(i);
+            auto& perStaProfile = GetPerStaProfile(GetNPerStaProfileSubelements() - 1);
+            perStaProfile.m_containingFrame = m_containingFrame;
+            i = perStaProfile.Deserialize(i);
             count = i.GetDistanceFrom(start);
-            break;
+        }
+        break;
         default:
             NS_ABORT_MSG("Unsupported Subelement ID: " << +i.PeekU8());
         }
